Package com.io7m.montarre.api

# Class MCopying.Builder

java.lang.Object
com.io7m.montarre.api.MCopying.Builder

Enclosing class:
  `MCopying`

public static final class MCopying.Builder extends Object
Builds instances of type `MCopying`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MCopying`
  `build()`
  Builds a new `MCopying`.
  `final MCopying.Builder`
  `from(MCopyingType instance)`
  Fill a builder with attribute values from the provided `MCopyingType` instance.
  `final MCopying.Builder`
  `setCopyright(String copyright)`
  Initializes the value for the `copyright` attribute.
  `final MCopying.Builder`
  `setLicense(String license)`
  Initializes the value for the `license` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final MCopying.Builder from(MCopyingType instance)
    Fill a builder with attribute values from the provided `MCopyingType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setLicense

    public final MCopying.Builder setLicense(String license)
    Initializes the value for the `license` attribute.
    Parameters:
      `license` - The value for license
    Returns:
      `this` builder for use in a chained invocation

  - ### setCopyright

    public final MCopying.Builder setCopyright(String copyright)
    Initializes the value for the `copyright` attribute.
    Parameters:
      `copyright` - The value for copyright
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public MCopying build()
    Builds a new `MCopying`.
    Returns:
      An immutable instance of MCopying
    Throws:
      `IllegalStateException` - if any required attributes are missing